#ifndef _TOKENIZER_H_
#define _TOKENIZER_H_

// uncomment the line below to get extra printfs for debugging purposes
//#define DEBUG_MODE

// the following constant defines the maximum number of tokens we can identify
// in a given string 
#define MAX_NB_TOKENS 255

enum token_type {INTEGER, FLOATING, OPERATOR, TEXT, UNKNOWN, NOTSET}; 
typedef enum token_type TokenType; 

union token_value {
	int 	integer; 
	double 	floating ;

}; 
typedef union token_value TokenValue; 

struct token {
	char* 		str; 
	TokenType	type;
	TokenValue	value;
}; 
typedef struct token Token; 

struct tokens { 
	Token** tokens; 
	int maxnbtokens; 
}; 
typedef struct tokens Tokens; 

void 		tokenize(Tokens* tokens, char * str); 
Tokens* 	tokens_allocate(int maxnbtokens); 
void 		tokens_display(Tokens* tokens); 
void 		tokens_deallocate(Tokens* tokens);
void 		tokens_identify(Tokens* p); 
double		tokens_evaluate(Tokens* p); 
int 		tokens_verify(Tokens* p); 

#endif
